// DJGPP code for Kalydaskope demo, by Chris Green 1996.
// ** Compile with: GCC KALY.C -O KALY.EXE **
// I am a newbie at C, so don't laugh at my code.
// Hi to Alex Clarke, Hitan Mistry and David Miller.

#include <stdio.h>
#include <stdlib.h> 
#include <math.h> 
#include <dos.h> 
#include <sys\nearptr.h> 

char scrbuf[200][320], palette[256][3], tgazoom[256][256];
long i, j, x, y; 
union REGS r;
char *scrptr; 
float fx, fy, zoomfactor, boring, sleepy; 
float zoomfactorx, zoomfactory, zoomfactorx2, zoomfactory2; 
float fyback, fxback, angle_rotation;

void ModeText(void) 
{ 
   r.h.ah=0; 
   r.h.al=0x03; 
   int86(0x10, &r, &r); 
} 

void Mode320x200(void) 
{ 
   r.h.ah=0; 
   r.h.al=0x13; 
   int86(0x10, &r, &r); 
} 

void TargaIn(char *filename) 
{        
   FILE *in; 
   if ( (in=fopen(filename, "rb")) == NULL ) 
   { 
      printf("TGA picture file %s is missing!\n", filename); 
      exit(1);                 
   } 
   fseek(in, 18, SEEK_SET);                 
   fread(palette, 768, 1, in); 
   fread(tgazoom, 65536, 1, in); 
   fclose(in); 
}        
 
void SetPal(void) 
{ 
   short i; 
   disable(); 
   outportb(0x3c8,0); 
   for (i=0; i<256; i++) 
   { 
      outportb(0x3c9, palette[i][2]>>2); 
      outportb(0x3c9, palette[i][1]>>2); 
      outportb(0x3c9, palette[i][0]>>2); 
   } 
   enable(); 
}

void display_tilerotate(float angle) 
{ 
   zoomfactorx=-zoomfactor*sin(angle); 
   zoomfactory=-zoomfactor*cos(angle); 
   zoomfactorx2=zoomfactor*sin(angle+(6.284/4)); 
   zoomfactory2=zoomfactor*cos(angle+(6.284/4)); 
   fy=0; 
   fx=0; 
   fyback=0; 
   fxback=0; 
   for (j=0; j<100; j++)
   {
      fx=fxback;    
      fy=fyback;
      for (i=0; i<160; i++)
      { 
         x=((long) fx)&255; 
         y=((long) fy)&255;             
         scrbuf[(j*2)][(i*2)]=tgazoom[y][x];
         scrbuf[199-(j*2)][(i*2)]=tgazoom[y][x];
         scrbuf[(j*2)][319-(i*2)]=tgazoom[y][x];
         scrbuf[199-(j*2)][319-(i*2)]=tgazoom[y][x];
         fx=fx+zoomfactorx;
         fy=fy+zoomfactory; 
      }
      fyback+=zoomfactory2; 
      fxback+=zoomfactorx2; 
   }
   memcpy(scrptr, scrbuf, 64000); 
} 
 
int main(void) 
{ 
   __djgpp_nearptr_enable(); 
   scrptr = (char*) (__djgpp_conventional_base + 0xa0000); 
 
   TargaIn("kaly.tga"); 
   Mode320x200(); 
   SetPal(); 
 
   angle_rotation=0;
   boring=0;
   sleepy=0;
   zoomfactor=2;
   while (!kbhit()) 
   { 
         display_tilerotate(angle_rotation);
         boring+=0.01;
         angle_rotation=2*sin(boring);
         angle_rotation+=5;
         sleepy+=0.03;
         zoomfactor=3*sin(sleepy);
         zoomfactor+=5;
   } 
   ModeText(); 
   return(0); 
}        
